/*******************************************************************************
 Copyright (c) Microsoft Open Technologies, Inc. All Rights Reserved.
 Licensed under the MIT or Apache License; see LICENSE in the source repository
 root for authoritative license information.﻿

 **NOTE** This code was generated by a tool and will occasionally be
 overwritten. We welcome comments and issues regarding this code; they will be
 addressed in the generation tool. If you wish to submit pull requests, please
 do so for the templates in that tool.

 This code was generated by Vipr (https://github.com/microsoft/vipr) using
 the T4TemplateWriter (https://github.com/msopentech/vipr-t4templatewriter).
 ******************************************************************************/
package com.microsoft.services.onenote.fetchers;

import com.microsoft.services.onenote.*;
import com.google.common.util.concurrent.*;
import com.microsoft.services.orc.core.*;
import com.microsoft.services.orc.core.Readable;

/**
 * The type  MyOrganizationFetcher.
 */
public class MyOrganizationFetcher extends OrcEntityFetcher<MyOrganization,MyOrganizationOperations> 
                                     implements Readable<MyOrganization> {

     /**
     * Instantiates a new MyOrganizationFetcher.
     *
     * @param urlComponent the url component
     * @param parent the parent
     */
     public MyOrganizationFetcher(String urlComponent, OrcExecutable parent) {
        super(urlComponent, parent, MyOrganization.class, MyOrganizationOperations.class);
    }

     /**
     * Add parameter.
     *
     * @param name the name
     * @param value the value
     * @return the fetcher
     */
    public MyOrganizationFetcher addParameter(String name, Object value) {
        addCustomParameter(name, value);
        return this;
    }

     /**
     * Add header.
     *
     * @param name the name
     * @param value the value
     * @return the fetcher
     */
    public MyOrganizationFetcher addHeader(String name, String value) {
        addCustomHeader(name, value);
        return this;
    }

        
     /**
     * Gets site collections.
     *
     * @return the site collections
     */
    public OrcCollectionFetcher<SiteCollection, SiteCollectionFetcher, SiteCollectionCollectionOperations> getSiteCollections() {
        return new OrcCollectionFetcher<SiteCollection, SiteCollectionFetcher, SiteCollectionCollectionOperations>("siteCollections", this, SiteCollection.class, SiteCollectionCollectionOperations.class);
    }

    /**
     * Gets site collection.
     *
     * @return the site collection
     */
    public SiteCollectionFetcher getSiteCollection(String id){
         return new OrcCollectionFetcher<SiteCollection, SiteCollectionFetcher, SiteCollectionCollectionOperations>("siteCollections", this, SiteCollection.class, SiteCollectionCollectionOperations.class).getById(id);
    }

}
